/*Elkulator v0.7 by Tom Walker
  Config file handling*/
#include <stdio.h>
#include "elk.h"

FILE *cfgfile;
unsigned char cfgbuffer[1024];

char *getstringcfg(char *name)
{
        char *t;
        int c;
        int a,b;
//        rpclog("Looking for %s\n",name);
        fseek(cfgfile,0,SEEK_SET);
        while (1)
        {
                t=fgets(cfgbuffer,1024,cfgfile);
                //rpclog("New string - %s\n",cfgbuffer);
                if (!t) return 0;
                c=0;
                while (name[c] && cfgbuffer[c])
                {
                        a=toupper(name[c]);
                        b=toupper(cfgbuffer[c]);
                        if (a!=b) break;
                        c++;
                }
                if (name[c]) continue;
                if (!cfgbuffer[c]) continue;
//                rpclog("Matched - now %s\n",&cfgbuffer[c]);
                while (cfgbuffer[c] && cfgbuffer[c]!='=') c++;
                if (!cfgbuffer[c]) continue;
                c++;
//                rpclog("Found equals - now %s\n",&cfgbuffer[c]);
                while (cfgbuffer[c] && cfgbuffer[c]==' ') c++;
                if (!cfgbuffer[c]) continue;
//                rpclog("Over! found %s\n",&cfgbuffer[c]);
                return &cfgbuffer[c];
        }
}

int getintcfg(char *name, int def)
{
        int c;
        char *s=getstringcfg(name);
        if (!s) return def;
//        rpclog("Returned string %s for %s\n",s,name);
        sscanf(s,"%i",&c);
//        rpclog("c is %i\n",c);
        return c;
}

void writestringcfg(char *name, char *s)
{
        if (s[0]) fprintf(cfgfile,"%s = %s\n",name,s);
}
void writeintcfg(char *name, int i)
{
        fprintf(cfgfile,"%s = %i\n",name,i);
}

void loadconfig()
{
        char *s;
        cfgfile=fopen("elk.cfg","rt");
        tapespeed=getintcfg("tapespeed",0);
        plus3=getintcfg("plus3",0);
        dfsena=getintcfg("dfsena",0);
        adfsena=getintcfg("adfsena",0);
        
        turbo=getintcfg("turbo",0);
        mrb=getintcfg("mrb",0);
        mrbmode=getintcfg("mrbmode",0);
        
        s=getstringcfg("discname_0");
        if (s)
        {
                strcpy(discname,s);
                loaddisc(discname,0);
        }
        else   discname[0]=0;
        s=getstringcfg("discname_1");
        if (s)
        {
                strcpy(discname2,s);
                loaddisc(discname2,0);
        }
        else   discname2[0]=0;

        fclose(cfgfile);
}

void saveconfig()
{
        cfgfile=fopen("elk.cfg","wt");
        writeintcfg("tapespeed",tapespeed);
        writeintcfg("plus3",plus3);
        writeintcfg("dfsena",dfsena);
        writeintcfg("adfsena",adfsena);
        
        writestringcfg("discname_0",discname);
        writestringcfg("discname_1",discname2);

        writeintcfg("turbo",turbo);
        writeintcfg("mrb",mrb);
        writeintcfg("mrbmode",mrbmode);
        fclose(cfgfile);
}
