/*Elkulator v0.7 by Tom Walker
  This was originally a limited Allegro->SDL wrapper, but has grown into an enormous mess*/
#include <SDL/SDL.h>
#include "sdlalleg.h"
#define BITMAP WINDOWS_BITMAP
#include "SDL_syswm.h"
#undef BITMAP

#include "elk.h"

void closesound();
void initsound();

typedef long fixed;

inline fixed ftofix(float f)
{
        return (fixed)(f*65536.0);
}

inline fixed itofix(int f)
{
        return f<<16;
}

inline int fixtoi(fixed f)
{
        return f>>16;
}

inline fixed fmul(fixed a, fixed b)
{
//      fixed r;
//        int64_a a64=(int64_t)
        int64_t temp=(int64_t)a*(int64_t)b;
//        rpclog("%08X * %08X = %08X\n",a,b,temp>>16);
        return temp>>16;
}

int infocus=1;

void clear();
void initpaltables();

#undef printf
void error(const char *format, ...)
{
   char buf[256];
   return;
   va_list ap;
   va_start(ap, format);
   vsprintf(buf, format, ap);
   va_end(ap);
   printf("%s",buf);
   exit(-1);
}

FILE *arclog;
void rpclog(const char *format, ...)
{
   char buf[256];
   return;
if (!arclog) arclog=fopen("log.txt","wt");
   va_list ap;
   va_start(ap, format);
   vsprintf(buf, format, ap);
   va_end(ap);
   fputs(buf,arclog);
   fflush(arclog);
}

SDL_Surface *scr,*backscr;

SDL_PixelFormat *fmt;

BITMAP *tempb16;

SDL_Thread *pollit;
int pollthreadon=0;

void allegro_init()
{
//        printf("SDL ON!!\n");
        if ((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER)==-1))
        {
                error("SDL failed to init!\n");
                exit(-1);
        }
        atexit(SDL_Quit);
//        pollthreadon=0;
//        pollit=SDL_CreateThread(pollthread,NULL);
}

void (*mainrun)();
int mainthread(void *p)
{
        while (!quited)
              mainrun();
}

void startsdl(void (*run)())
{
        mainrun=run;
        pollit=SDL_CreateThread(mainthread,NULL);
//        pollthreadon=1;
}

void allegro_exit()
{
        quited=1;
        SDL_KillThread(pollit);
        SDL_CloseAudio();
}

void set_gfx_mode(int c, int x, int y, int vx, int vy)
{
//        printf("SET GFX MODE %i,%i\n",x,y);
        if (c==GFX_AUTODETECT_FULLSCREEN) scr=SDL_SetVideoMode(x, y, 16, SDL_SWSURFACE|SDL_ANYFORMAT|SDL_FULLSCREEN);
        else                              scr=SDL_SetVideoMode(x, y, 16, SDL_SWSURFACE|SDL_ANYFORMAT);
        if (!scr)
        {
                error("SDL failed to init video!\n");
                exit(-1);
        }
        fmt=scr->format;
        Init_2xSaI(16);
//        printf("%i bpp\n",fmt->BitsPerPixel);
        if (!screen) screen=malloc(sizeof(BITMAP));
        backscr=SDL_CreateRGBSurface(SDL_SWSURFACE,320,256,16,fmt->Rmask,fmt->Gmask,fmt->Bmask,fmt->Amask);
        if (!tempb16) tempb16=create_bitmap(320*2,256);
        initpaltables();
//        clear();
}

unsigned long makecol(int r, int g, int b)
{
        unsigned long temp;
//        printf("Makecol %i %i %i  ",r,g,b);
        r>>=fmt->Rloss;
        r<<=fmt->Rshift;
        r&=fmt->Rmask;
        g>>=fmt->Gloss;
        g<<=fmt->Gshift;
        g&=fmt->Gmask;
        b>>=fmt->Bloss;
        b<<=fmt->Bshift;
        b&=fmt->Bmask;
//        printf("%08X\n",r|g|b);
        return r|g|b;
}

#define getr(col) (((col&fmt->Rmask)>>fmt->Rshift)<<fmt->Rloss)
#define getg(col) (((col&fmt->Gmask)>>fmt->Gshift)<<fmt->Gloss)
#define getb(col) (((col&fmt->Bmask)>>fmt->Bshift)<<fmt->Bloss)
/*int getr(unsigned short col)
{
        return ((col&fmt->Rmask)>>fmt->Rshift)<<fmt->Rloss;
}
int getg(unsigned short col)
{
        return ((col&fmt->Gmask)>>fmt->Gshift)<<fmt->Gloss;
}
int getb(unsigned short col)
{
        return ((col&fmt->Bmask)>>fmt->Bshift)<<fmt->Bloss;
}*/

unsigned long makecol_depth(int d, int r, int g, int b)
{
        return makecol(r,g,b);
}

void install_keyboard()
{
}

void install_mouse()
{
}

SDL_TimerID vblankhandle;

uint32_t SDLvblank(uint32_t interval, void *param)
{
        drawitint();
        return 20;
}

void install_int_ex(void *rout, int time)
{
//        printf("INSTALL INT!\n");
        if (rout==drawitint) vblankhandle=SDL_AddTimer(1000,SDLvblank,NULL);
}

void install_timer()
{
}

BITMAP *create_bitmap(int x, int y)
{
        int c;
        BITMAP *b=malloc(sizeof(BITMAP)+(y*(sizeof(unsigned char *))));
        b->h=b->y=y;
        b->w=b->x=x;
        b->cl=b->ct=0;
        b->cr=x-1;
        b->ct=y-1;
        b->dat=malloc(x*y);
        for (c=0;c<y;c++)
        {
                b->line[c]=&b->dat[c*x];
                memset(b->line[c],0,x);
        }
//        printf("Create bitmap with %i lines of %i bytes\n",y,x);
        return b;
}

int bitmap_color_depth(BITMAP *b)
{
        return 16;
}

void destroy_bitmap(BITMAP *b)
{
        int c;
        if (!b) return;
        for (c=0;c<b->y;c++)
        {
                if (b->line[c]) free(b->line[c]);
        }
        free(b);
}

unsigned long transpalette[256];

void set_palette(PALETTE pal)
{
        int c;
        for (c=0;c<256;c++)
        {
                transpalette[c]=SDL_MapRGB(fmt,pal[c].r<<2,pal[c].g<<2,pal[c].b<<2);
        }
}

void blit(BITMAP *src, BITMAP *dest, int x1, int y1, int x2, int y2, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
//        src=tempb16;
        if (dest==screen) /*Blitting to screen*/
        {
                SDL_LockSurface(scr);
                for (y=0;y<ys;y++)
                {
                        scrp=(uint8_t *)scr->pixels + ((y+y2) * scr->pitch) + (x2 * bpp);
                        for (x=0;x<xs;x++)
                        {
                                ((uint16_t *)scrp)[x]=((uint16_t *)src->line[y+y1])[x+x1];
                        }
                }
                SDL_UnlockSurface(scr);
                SDL_UpdateRect(scr,x2,y2,xs,ys);
        }
}
void blitscan(BITMAP *src, BITMAP *dest, int x1, int y1, int x2, int y2, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
        if (dest==screen) /*Blitting to screen*/
        {
                SDL_LockSurface(scr);
                for (y=0;y<ys;y+=2)
                {
                        scrp=(uint8_t *)scr->pixels + ((y+y2) * scr->pitch) + (x2 * bpp);
                        for (x=0;x<xs;x++)
                        {
                                ((uint16_t *)scrp)[x]=transpalette[src->line[(y>>1)+y1][x+x1]&255];
                        }
                }
                SDL_UnlockSurface(scr);
                SDL_UpdateRect(scr,x2,y2,xs,ys);
        }
}
void blitscan16(BITMAP *src, BITMAP *dest, int x1, int y1, int x2, int y2, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
        if (dest==screen) /*Blitting to screen*/
        {
                SDL_LockSurface(scr);
                for (y=0;y<ys;y+=2)
                {
                        scrp=(uint8_t *)scr->pixels + ((y+y2) * scr->pitch) + (x2 * bpp);
                        for (x=0;x<xs;x++)
                        {
                                ((uint16_t *)scrp)[x]=((uint16_t *)src->line[(y>>1)+y1])[x+x1];
                        }
                }
                SDL_UnlockSurface(scr);
                SDL_UpdateRect(scr,x2,y2,xs,ys);
        }
}
void blitdbl(BITMAP *src, BITMAP *dest, int x1, int y1, int x2, int y2, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp,*scrp2;
        if (dest==screen) /*Blitting to screen*/
        {
                SDL_LockSurface(scr);
                for (y=0;y<ys;y+=2)
                {
                        scrp=(uint8_t *)scr->pixels + ((y+y2) * scr->pitch) + (x2 * bpp);
                        scrp2=(uint8_t *)scr->pixels + ((y+y2+1) * scr->pitch) + (x2 * bpp);
                        for (x=0;x<xs;x++)
                        {
                                ((uint16_t *)scrp2)[x]=((uint16_t *)scrp)[x]=transpalette[src->line[(y>>1)+y1][x+x1]&255];
                        }
                }
                SDL_UnlockSurface(scr);
                SDL_UpdateRect(scr,x2,y2,xs,ys);
        }
}

void blit8to16(BITMAP *src, BITMAP *dest, int x1, int y1, int x2, int y2, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
        for (y=0;y<ys;y++)
        {
                for (x=0;x<xs;x++)
                {
                        ((uint16_t *)dest->line[y+y1])[x]=transpalette[src->line[y+y1][x+x1]&255];
                }
        }
}

void blit2xsai(BITMAP *src, BITMAP *dst, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
        for (y=0;y<ys;y++)
        {
                for (x=0;x<xs;x++)
                {
                        ((uint16_t *)tempb16->line[y])[x]=transpalette[src->line[y][x]&255];
                }
        }
        Super2xSaI(tempb16,dst,0,0,0,0,320,256);
}

void bliteagle(BITMAP *src, BITMAP *dst, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
        for (y=0;y<ys;y++)
        {
                for (x=0;x<xs;x++)
                {
                        ((uint16_t *)tempb16->line[y])[x]=transpalette[src->line[y][x]&255];
                }
        }
        SuperEagle(tempb16,dst,0,0,0,0,320,256);
}

void blitscale2x(BITMAP *src, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
        SDL_LockSurface(backscr);
        for (y=0;y<ys;y++)
        {
                scrp=(uint8_t *)backscr->pixels + (y * backscr->pitch);
                for (x=0;x<xs;x++)
                {
                        ((uint16_t *)scrp)[x]=transpalette[src->line[y][x]&255];
                }
        }
        SDL_LockSurface(scr);
        scale2x(backscr,scr);
        SDL_UnlockSurface(backscr);
        SDL_UnlockSurface(scr);
        SDL_UpdateRect(scr,0,0,xs*2,ys*2);
}

void stretch_blit(BITMAP *s, BITMAP *d, int sx, int sy, int sw, int sh, int dx, int dy, int dw, int dh)
{
}

BITMAP *create_sub_bitmap(BITMAP *s, int x, int y, int w, int h)
{
        return NULL;
}

void clear()
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
                SDL_LockSurface(scr);
                for (y=0;y<512;y++)
                {
                        scrp=(uint8_t *)scr->pixels + (y * scr->pitch);
                        for (x=0;x<640;x++)
                        {
                                ((uint16_t *)scrp)[x]=0;
                        }
                }
                SDL_UnlockSurface(scr);
                SDL_UpdateRect(scr,0,0,640,512);
}

int quited=0;
void poll_sdl()
{
        SDL_Event event;
        unsigned char *k;
        int c;
        while(SDL_PollEvent(&event))
        {
//                rpclog("Event %i!\n",event.type);
                switch(event.type)
                {
                        case SDL_MOUSEMOTION:
                        mouse_x=event.motion.x;
                        mouse_y=event.motion.y;
                        mouse_b=0;
                        if (event.motion.state&SDL_BUTTON(1)) mouse_b|=1;
                        if (event.motion.state&SDL_BUTTON(2)) mouse_b|=4;
                        if (event.motion.state&SDL_BUTTON(4)) mouse_b|=2;
                        break;
                        case SDL_MOUSEBUTTONDOWN:
                        case SDL_MOUSEBUTTONUP:
                        mouse_b=0;
                        if (event.button.state&SDL_BUTTON(1)) mouse_b|=1;
                        if (event.button.state&SDL_BUTTON(2)) mouse_b|=4;
                        if (event.button.state&SDL_BUTTON(4)) mouse_b|=2;
                        break;
                        case SDL_QUIT:
                        quited=1;
                        break;
                        case SDL_KEYDOWN:
                        key[event.key.keysym.sym]=1;
//                        rpclog("KEY DOWN %02X %i\n",event.key.keysym.sym,event.key.keysym.sym);
                        break;
                        case SDL_KEYUP:
                        key[event.key.keysym.sym]=0;
                        break;
                	case SDL_SYSWMEVENT:
//                                rpclog("SYSWMEVENT! %i\n",event.syswm.msg->msg);
        		switch(event.syswm.msg->msg)
        		{
                		case WM_COMMAND:
                                handlemenu(event.syswm.msg);
                                resetsound();
                                break;
                                /*Go on then, see if I care mr SDL*/
                                #if 0
                                case WM_SETFOCUS:
                                resetsound();
                                infocus=1;
                                SDL_PauseAudio(0);
                                cleardrawit();
                                break;
                                case WM_KILLFOCUS:
                                infocus=0;
                                SDL_PauseAudio(1);
                                break;
                                case WM_ENTERMENULOOP:
//                                        rpclog("Enter menu loop!\n");
//                                pollthreadon=1;
                                infocus=0;
//                                closesound();
//                                SDL_PauseAudio(1);
                                rpclog("Sound paused\n");
                                break;
                                case WM_EXITMENULOOP:
                                infocus=1;
                                resetsound();
//                                initsound();
//                                SDL_PauseAudio(0);
                                cleardrawit();
                                rpclog("Sound resumed\n");
                                pollthreadon=0;
                                break;
                                #endif
                        }
//                        rpclog("Focus %i\n",infocus);
                        break;
                        /*This is pointless and doesn't seem to actually work properly*/
                        /*Elkulator is now unstoppable*/
                        #if 0
                        case SDL_ACTIVEEVENT:
                        if (event.active.state==SDL_APPINPUTFOCUS)
                        {
                                if (event.active.gain)
                                {
                                        rpclog("Gained SDL focus!\n");
                                        if (!infocus)
                                        {
                                                resetsound();
                                                cleardrawit();
                                        }
                                        infocus=1;
                                }
                                else
                                {
                                        infocus=0;
                                        rpclog("Lost SDL focus\n");
                                }
                        }
                        break;
                        #endif
                }
        }
        mouse_b=0;
        if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON_LMASK) mouse_b|=1;
        if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON_RMASK) mouse_b|=2;
        if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON_MMASK) mouse_b|=4;
//        k=SDL_GetKeyState(NULL);
//        for (c=0;c<512;c++) key[c]=k[c];
}

unsigned char sndbuffers[8192];
int soundwrite,soundread,soundlen;
FILE *soundf;

void addsound(unsigned char dat)
{
//        rpclog("Addsound %02X %03X\n",dat,soundwrite&0xFFF);
        sndbuffers[soundwrite&0x1FFF]=dat;
        soundwrite++;
//        if (!soundf) soundf=fopen("sound.pcm","wb");
//        putc(dat,soundf);
}

void wipesoundbuffer()
{
        memset(sndbuffers,0,8192);
}

#define NCoef 4
float soundiir(float NewSample) {
    float ACoef[NCoef+1] = {
        0.30631912757971225000,
        0.00000000000000000000,
        -0.61263825515942449000,
        0.00000000000000000000,
        0.30631912757971225000
    };

    float BCoef[NCoef+1] = {
        1.00000000000000000000,
        -1.86772356053227330000,
        1.08459167506874430000,
        -0.37711292573951394000,
        0.17253125052500490000
    };

    static float y[NCoef+1]; //output samples
    static float x[NCoef+1]; //input samples
    int n;

    //shift the old samples
    for(n=NCoef; n>0; n--) {
       x[n] = x[n-1];
       y[n] = y[n-1];
    }

    //Calculate the new output
    x[0] = NewSample;
    y[0] = ACoef[0] * x[0];
    for(n=1; n<=NCoef; n++)
        y[0] += ACoef[n] * x[n] - BCoef[n] * y[n];

    return y[0];
}
#undef NCoef

int closingaudio;
int waiting,resetit;
void mixsound(void *userdata, Uint8 *stream, int len)
{
        int c;
//        rpclog("Mixsound - infocus %i\n",infocus);
/*        if (!infocus)
        {
                memset(stream,0,len);
                return;
        }*/
        if (closingaudio) return;
        if (!infocus)
        {
                memset(stream,0,len);
                return;
        }
//        if ((soundwrite-soundread)<len) rpclog("Waiting! - %i\n",soundwrite-soundread);
        while ((soundwrite-soundread)<len)
        {
                if (quited) return;
                if (closingaudio) return;
                sleep(0);
        }
//        rpclog("Mixing %i bytes %i %i\n",len,soundread,soundwrite);
        for (c=0;c<len;c++)
        {
//                if (waiting || resetit) stream[c]=0;
                /*else                    */stream[c]=((int)soundiir((float)sndbuffers[soundread&0x1FFF]/2))^0x80;
//                rpclog("Mix %02X %03X\n",stream[len],soundread&0xFFF);
                soundread++;
        }
//        if (!soundf) soundf=fopen("sound.pcm","wb");
//        fwrite(stream,len,1,soundf);
}

void resetsound()
{
//        closesound();
//        soundread=0;
//        soundwrite=2048;
//        memset(sndbuffers,0,2048);
//        initsound();
}

void initsound()
{
        SDL_AudioSpec *desired, *obtained;
        closingaudio=0;

        desired = malloc(sizeof(SDL_AudioSpec));
        obtained = malloc(sizeof(SDL_AudioSpec));

        desired->freq=31250;
        desired->format=AUDIO_U8;
        desired->channels=1;
        desired->samples=2048;
        desired->callback=mixsound;

        desired->userdata=NULL;

        /* Open the audio device */
        if (SDL_OpenAudio(desired, obtained) < 0 )
        {
                error("Couldn't open audio: %s\n", SDL_GetError());
                exit(-1);
        }
        free(desired);
        free(obtained);
        SDL_PauseAudio(0);
        
        soundwrite=soundread=soundlen=0;
}

void closesound()
{
        SDL_LockAudio();
        SDL_CloseAudio();
        SDL_UnlockAudio();
}


fixed ACoef[2],ACoef2[2];
fixed BCoef[2],BCoef2[2];

void initcoef()
{
        ACoef[0]=ACoef[1]=ftofix(0.13673463961326307000);
        BCoef[0]=itofix(1);
        BCoef[1]=ftofix(-0.72654252800536090000);
        ACoef2[0]=ftofix(0.29289321881333563000);
        ACoef2[1]=ftofix(0.58578643762667126000);
        ACoef2[2]=ftofix(0.29289321881333563000);
        BCoef2[2]=ftofix(0.17157287525380990000);
        rpclog("%08X %08X %08X %08X\n",ACoef2[0],ACoef2[1],ACoef2[2],BCoef2[2]);
}


#define NCoef 2

fixed yy[NCoef+2]; //output samples
fixed yx[NCoef+2]; //input samples
int ycount=0;
inline fixed iir(fixed NewSample)
{
        yx[ycount] = NewSample;
        yy[ycount] = fmul(ACoef2[0],yx[ycount]);
        yy[ycount] += fmul(ACoef2[1],yx[(ycount+1)&3]);// - BCoef2[1] * yy[(ycount+1)&3];
        yy[ycount] += fmul(ACoef2[2],yx[(ycount+2)&3]) - fmul(BCoef2[2],yy[(ycount+2)&3]);
        ycount=(ycount-1)&3;
        return yy[(ycount+1)&3];
}

fixed ry[2]; //output samples
fixed rx[2]; //input samples
int rycount=0;

inline fixed firry(fixed NewSample) {
    //Calculate the new output
    rx[rycount] = fmul(ACoef[0],NewSample);
    ry[rycount] = rx[0]+rx[1];
    ry[rycount] -= fmul(BCoef[1],ry[rycount^1]);
    rycount^=1;
    return ry[rycount^1];
}

fixed by[2]; //output samples
fixed bx[2]; //input samples
int bycount=0;
    
inline fixed firby(fixed NewSample) {
    //Calculate the new output
    bx[bycount] = fmul(ACoef[0],NewSample);
    by[bycount] = bx[0]+bx[1];
    by[bycount] -= fmul(BCoef[1],by[bycount^1]);
    bycount^=1;
    return by[bycount^1];
}

int rtable[8],gtable[8],btable[8];
fixed ytable[8];

void initpaltables()
{
        int c;
        for (c=0;c<8;c++)
        {
                rtable[c]=(c&1)?255:0;
                gtable[c]=(c&2)?255:0;
                btable[c]=(c&4)?255:0;
                ytable[c]=ftofix((rtable[c]*0.299f)+(gtable[c]*0.587)+(btable[c]*0.114));
        }
        initcoef();
}

void palfilter(BITMAP *src, BITMAP *dest)
{
        int x,y,c;
        int r,g,b;
        fixed constr=ftofix(-0.509f),constb=ftofix(0.194);
        fixed paly,palry,palby;
        for (y=0;y<256;y++)
        {
                yx[2]=yx[1]=yx[0]=0;
                yy[2]=yy[1]=yy[0]=0;
                rx[0]=ry[0]=rx[1]=ry[1]=0;
                bx[0]=by[0]=bx[1]=by[1]=0;
//                iir(0,1);
                for (x=0;x<640;x++)
                {
                        c=src->line[y][x]&7;
                        r=(c&1)?255:0; g=(c&2)?255:0; b=(c&4)?255:0;
                        paly=ytable[c];

                        palry=itofix(r)-paly;
                        palby=itofix(b)-paly;
                        
                        paly=iir(paly);
                        if (paly>(255<<16)) paly=255<<16;
                        if (paly<0)   paly=0;
                        
                        palry=firry(palry);
                        palby=firby(palby);
                        
                        r=fixtoi(palry+paly);
                        b=fixtoi(palby+paly);
                        g=fixtoi((fmul(constr,palry)-fmul(constb,palby))+paly);

                        if (r>255) r=255;
                        if (r<0)   r=0;
                        if (g>255) g=255;
                        if (g<0)   g=0;
                        if (b>255) b=255;
                        if (b<0)   b=0;

                        ((unsigned short *)dest->line[y])[x]=makecol(r,g,b);
                }
        }
}

void blitfilter(BITMAP *src, BITMAP *dest, int x1, int y1, int x2, int y2, int xs, int ys)
{
        int y,x;
        int bpp=16;
        uint8_t *scrp;
        for (y=0;y<ys;y++)
        {
                for (x=0;x<xs;x++)
                {
                        ((uint16_t *)dest->line[y+y1])[x]=transpalette[src->line[y+y1][x+x1]&255];
                }
        }
//        palfilter(dest);
}

